# Overview

This subordinate charm provides live kernel updates to its unit via the [Canonical Livepatch Service](https://www.ubuntu.com/server/livepatch).

The canonical-livepatch software is automatically installed from the Snap Store.

You will need to supply your key from https://ubuntu.com/livepatch via juju set (1.x) or juju config (2.x)

Nagios checks are automatically deployed if you add an appropriate nrpe-external-master relation.

# Usage

This is a subordinate charm, so must be related to your primary service(s):

    juju deploy canonical-livepatch

    juju add-relation <your_primary_charm_name> canonical-livepatch

You will need to supply your key from https://ubuntu.com/livepatch via juju set (Juju 1.x):

    juju set canonical-livepatch livepatch_key=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

Or via juju config (Juju 2.x)

    juju config canonical-livepatch livepatch_key=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

# Configuration

The livepatch_key setting must be configured in order for the software to function correctly - see above.

By default, the livepatch software will attempt to retrieve its patch data directly over the network. If you'd like to use a proxy for this traffic instead, you can set the livepatch_proxy value to the address of your proxy server.

Likewise, if you need to use a proxy server to access the Snap Store, snap_proxy can also be set to the address of your proxy server.

Alternatively, if you've configured a proxy for all applications in your environment via juju model-config, the charm will detect this and automatically do the right thing. It'll use http-proxy or https-proxy if either are set, with the latter being preferred.

If two different proxies are set via model config and charm config, the latter will be preferred.

# Testing

To run tests use: `make test`

Note: functional tests are not available on trusty.

# Contact Information

This charm is maintained here, by the llama-charmers team:

https://launchpad.net/charm-canonical-livepatch

## Canonical Livepatch Service

https://www.ubuntu.com/server/livepatch
